#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <string>
#include <climits>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <list>
#include <ctime>
#include <iostream>
#include <sstream>
#include <cctype>

#define PI 3.14159265358979
#define EPS 1e-9

using namespace std;

#define REP(i, n) for (int i=0; i<n; i++)
#define FOR(i, m, n) for (int i=m; i<=n; i++)
#define ABS(a) (((a)>0)?(a):(-(a)))
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int,int> ii;

int n, k;
int tar[1111];		// Dopředná hrana
vector<int> back[1111]; // Zpětné hrany
int seen[1111];		// Indikátor navštívení vrcholu
int M[1111];		// Batoh
vector<ii> w;		// Seznam věcí velikosti [a_i, b_i]

int main() {
	scanf("%d%d", &n, &k);
	REP(i, n) {
		int x; scanf("%d", &x); x--;
		tar[i] = x;
		back[x].push_back(i);
	}
	// Najdi cykly a ocasy
	REP(i, n) if (seen[i]==0) {
		int p = i;
		seen[p] = 1;
		while (seen[tar[p]]==0) {
			seen[tar[p]] = seen[p]+1;
			p = tar[p];
		}
		int l = seen[p];
		int r = 0;
		queue<int> q; q.push(p);
		seen[p] = -1;
		while (!q.empty()) {
			int u = q.front(); q.pop();
			r++;
			for (int v : back[u]) {
				if (seen[v]!=-1) {
					q.push(v);
					seen[v] = -1;
				}
			}
		}
		// Přidání věci pro problém batohu
		w.push_back(make_pair(l, r));
	}
	// Modifikace problemu batohu
	M[0] = 1;
	REP(i, w.size()) {
		int l = w[i].first; int r = w[i].second;
		for (int j=k; j>=l; j--) if (M[j-l]==1) {
			for (int q=j; q<=k && q<=j-l+r; q++) M[q] = 1;
		}
	}
	int res = k;
	while (M[res]==0) res--;
	printf("%d\n", res);
	return 0;
}
