#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <string>
#include <climits>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <list>
#include <ctime>
#include <iostream>
#include <sstream>
#include <cctype>

#define PI 3.14159265358979
#define EPS 1e-9

using namespace std;

#define REP(i, n) for (int i=0; i<n; i++)
#define FOR(i, m, n) for (int i=m; i<=n; i++)
#define ABS(a) (((a)>0)?(a):(-(a)))
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int,int> ii;

struct Hrana {
	int u;
	int v;
	int val;
	bool checked;
};

int n, m;
vector<int> graf[11111];
vector<Hrana> hrany;
ll sum = 0;
int seen[11111];	// Indikátor navštívenosti
int akt[11111];		// Aktuální pozice v seznamu hran
vector<Hrana> path;

// Prohledávání do hloubky s vlastním zásobníkem
// Při rekurzivním přístupu dochází paměť na stacku
void euler(int start, Hrana &IN) {
	stack<int> st;
	stack<Hrana> sth;
	st.push(start); sth.push(IN);
	while (!st.empty()) {
		int u = st.top(); Hrana in = sth.top();
		// Hledáme další nepoužitou hranu
		while (akt[u] < graf[u].size()) {
			if (hrany[graf[u][akt[u]]].checked==false) {
				int i = graf[u][akt[u]];
				Hrana &h = hrany[i];
				h.checked = true;
				int v = (u==h.u)?h.v:h.u;
				st.push(v); sth.push(h);
				break;
			}
			akt[u]++;
		}
		// Pokud jsme na konci seznamu hran aktuálního
		// vrcholu, kreslíme hranu (nejsme-li v úplném začátku).
		if (in.u!=-1 && akt[u]==graf[u].size()) {
			path.push_back(in);
		}
		if (akt[u]==graf[u].size()) {
			st.pop(); sth.pop();
		}
	}
}

int main() {
	scanf("%d%d", &n, &m);
	REP(i, m) {
		Hrana h;
		scanf("%d%d%d", &h.u, &h.v, &h.val); h.u--; h.v--;
		hrany.push_back(h);
		graf[h.u].push_back(i);
		graf[h.v].push_back(i);
		sum += h.val;
	}
	// Součet je záporný
	if (sum < 0) {
		printf("-1\n"); return 0;
	}
	// Kontrola sudosti stupňů
	REP(i, n) {
		if (graf[i].size()%2) {
			printf("-1\n"); return 0;
		}
	}
	Hrana zbytecna = {-1, -1, 0};
	int start = 0; while (graf[start].size()==0) start++;
	euler(start, zbytecna);
	// Neprošli jsme všechny hrany
	if (path.size()!=m) {
		printf("-1\n"); return 0;
	}
	// Hledání minima
	ll min_pref = 0;
	int min_v = 0;
	int index = 0;
	ll pref = 0;
	int v = 0;
	REP(i, path.size()) {
		pref += path[i].val;
		v = (v==path[i].u) ? path[i].v : path[i].u;
		if (pref < min_pref) {
			min_pref = pref;
			min_v = v;
			index = i+1;
		}
	}
	v = min_v;
	// Výpis výsledku
	printf("%d\n", v+1);
	REP(i, m) {
		int j = (index+i)%m;
		int u = v;
		v = (v==path[j].u) ? path[j].v : path[j].u;
		printf("%d %d %d\n", u+1, v+1, path[j].val);
	}
	return 0;
}
